# 指令

所有扩展功能都需要用指令实现，通过这种方式精简核心包的体积。

## 规范

指令是一个函数，调用时会传入一个对象，结构如下：

```js
{
  el: 'DOM 元素',
  node: '指令对应的语法树节点',
  instance: '指令所属组件实例，和 component 不是一个概念',
  directives: 'DOM 元素上绑定的其他指令，有时需要用到其他指令的数据',
  attrs: 'DOM 元素上声明的属性',
  component: '如果是作用于组件的指令，会传入该组件的实例'
}
```

如有需要，指令函数应返回一个销毁函数。
